import java.net.*;

class Environment implements IEnvironment{
    private static final URL[] classPath;
    private AbstractLoadableClass program;

    static{
        try{
            classPath = new URL[]{new URL("file:/mnt/floppy/")};
        }catch (java.net.MalformedURLException e){
            throw new ExceptionInInitializerError(e);
        }
    }

    public static void main(String[] args){
        System.out.println("class: Environment, method: main");

        Environment environment = new Environment();
        if(args.length <1){
            System.out.println("like .. I need some class dude");
            return;
        }
        environment.run(args[0]);
    }

    public void run(String programName){
        System.out.println("class: Environment, method: run");
        URLClassLoader classLoader = new URLClassLoader(classPath);
        Class programClass;
        try{
            programClass = classLoader.loadClass(programName);
        }catch(ClassNotFoundException e){System.out.println("class not found");return;}
        
        try{
            program = (AbstractLoadableClass)programClass.newInstance();
        }catch(Exception e){return;}

        program.setEnvironment(this);
        program.start();
    }

    public void function_1(){
        System.out.println("class: Environment, method: function_1");
    }

    public void function_2(){
        System.out.println("class: Environment, method: function_2");
    }
    
    public void function_3(){
        System.out.println("class: Environment, method: function_3");
    }
    
    public void function_4(){
        System.out.println("class: Environment, method: function_4");
    }
    
    public void function_5(){
        System.out.println("class: Environment, method: function_5");
    }
}
